#include <stdlib.h>
#include <stddef.h>

typedef struct ls_list {
	struct ls_list *next;
} ls_list;

/* create a new list, initialized via fp */
ls_list *ls_new(size_t, void (*)(ls_list *));

/* free a list, calling fp on each member */
void ls_free(ls_list *, void (*)(ls_list *));

/* add the 2nd list after the first one, returning the head */
ls_list *ls_append(ls_list *, ls_list *);

/* add the 2nd list before the first one, returning new head */
ls_list *ls_push(ls_list *, ls_list *);

/* sort a list, using the given comparison function */
ls_list *ls_sort(ls_list *, int, int (*)(const ls_list *, const ls_list *));

/* iterate through a list, calling a function, and returning the first
 * member for which func returns non-zero. */
ls_list *ls_iter(ls_list *, int (*)(ls_list *));

/* reverse */
ls_list *ls_rev(ls_list *);
